/* JobsView.c generated by valac 0.54.8, the Vala compiler
 * generated from JobsView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2015 - 2022 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include "cups/cups.h"
#include <gee.h>
#include <float.h>
#include <math.h>

enum  {
	PRINTERS_JOBS_VIEW_0_PROPERTY,
	PRINTERS_JOBS_VIEW_NUM_PROPERTIES
};
static GParamSpec* printers_jobs_view_properties[PRINTERS_JOBS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block9Data Block9Data;

struct _PrintersJobsViewPrivate {
	PrintersPrinter* printer;
	GtkListBox* list_box;
	GtkButton* clear_button;
};

struct _Block8Data {
	int _ref_count_;
	PrintersJobsView* self;
	PrintersPrinter* printer;
};

struct _Block9Data {
	int _ref_count_;
	PrintersJobsView* self;
	PrintersClearQueueDialog* dialog;
};

static gint PrintersJobsView_private_offset;
static gpointer printers_jobs_view_parent_class = NULL;

static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void printers_jobs_view_update_header (PrintersJobRow* row1,
                                       PrintersJobRow* row2,
                                       PrintersJobsView* self);
static gint printers_jobs_view_compare (PrintersJobRow* a,
                                 PrintersJobRow* b);
static void printers_jobs_view_refresh_job_list (PrintersJobsView* self);
static void __lambda9_ (Block8Data* _data8_,
                 const gchar* text,
                 const gchar* printer_uri,
                 const gchar* name,
                 guint32 state,
                 const gchar* state_reasons,
                 gboolean is_accepting_jobs,
                 guint32 job_id,
                 guint32 job_state,
                 const gchar* job_state_reason,
                 const gchar* job_name,
                 guint32 job_impressions_completed);
static void ___lambda9__cups_notifier_job_created (CupsNotifier* _sender,
                                            const gchar* text,
                                            const gchar* printer_uri,
                                            const gchar* name,
                                            guint32 state,
                                            const gchar* state_reasons,
                                            gboolean is_accepting_jobs,
                                            guint32 job_id,
                                            guint32 job_state,
                                            const gchar* job_state_reason,
                                            const gchar* job_name,
                                            guint32 job_impressions_completed,
                                            gpointer self);
static void __lambda10_ (PrintersJobsView* self);
static void ___lambda10__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda11_ (Block9Data* _data9_,
                  gint response_id);
static void ___lambda12_ (PrintersJobsView* self,
                   GtkWidget* row);
static void ____lambda12__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void ___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void __lambda8_ (PrintersJobsView* self,
                 GtkWidget* row);
static void ___lambda8__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void printers_jobs_view_finalize (GObject * obj);
static GType printers_jobs_view_get_type_once (void);

static inline gpointer
printers_jobs_view_get_instance_private (PrintersJobsView* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersJobsView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		PrintersJobsView* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->printer);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
__lambda9_ (Block8Data* _data8_,
            const gchar* text,
            const gchar* printer_uri,
            const gchar* name,
            guint32 state,
            const gchar* state_reasons,
            gboolean is_accepting_jobs,
            guint32 job_id,
            guint32 job_state,
            const gchar* job_state_reason,
            const gchar* job_name,
            guint32 job_impressions_completed)
{
	PrintersJobsView* self;
	cups_dest_t _tmp0_;
	const gchar* _tmp1_;
	GeeTreeSet* jobs_ = NULL;
	GeeTreeSet* _tmp2_;
	GtkButton* _tmp15_;
	GtkListBox* _tmp16_;
	GList* _tmp17_;
	GList* _tmp18_;
	self = _data8_->self;
	g_return_if_fail (text != NULL);
	g_return_if_fail (printer_uri != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (state_reasons != NULL);
	g_return_if_fail (job_state_reason != NULL);
	g_return_if_fail (job_name != NULL);
	_tmp0_ = _data8_->printer->dest;
	_tmp1_ = _tmp0_.name;
	if (g_strcmp0 (_tmp1_, name) != 0) {
		return;
	}
	_tmp2_ = printers_printer_get_jobs (_data8_->printer, TRUE, CUPS_WHICHJOBS_ALL);
	jobs_ = _tmp2_;
	{
		GeeIterator* _job_it = NULL;
		GeeTreeSet* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp3_ = jobs_;
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
		_job_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			PrintersJob* job = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			PrintersJob* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			_tmp5_ = _job_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _job_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			job = (PrintersJob*) _tmp7_;
			_tmp8_ = job;
			_tmp9_ = printers_job_get_uid (_tmp8_);
			_tmp10_ = _tmp9_;
			if (((guint32) _tmp10_) == job_id) {
				GtkListBox* _tmp11_;
				PrintersJob* _tmp12_;
				PrintersJobRow* _tmp13_;
				PrintersJobRow* _tmp14_;
				_tmp11_ = self->priv->list_box;
				_tmp12_ = job;
				_tmp13_ = printers_job_row_new (_data8_->printer, _tmp12_);
				g_object_ref_sink (_tmp13_);
				_tmp14_ = _tmp13_;
				gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp14_);
				_g_object_unref0 (_tmp14_);
				_g_object_unref0 (job);
				break;
			}
			_g_object_unref0 (job);
		}
		_g_object_unref0 (_job_it);
	}
	_tmp15_ = self->priv->clear_button;
	_tmp16_ = self->priv->list_box;
	_tmp17_ = gtk_container_get_children ((GtkContainer*) _tmp16_);
	_tmp18_ = _tmp17_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, g_list_length (_tmp18_) > ((guint) 0));
	(_tmp18_ == NULL) ? NULL : (_tmp18_ = (g_list_free (_tmp18_), NULL));
	_g_object_unref0 (jobs_);
}

static void
___lambda9__cups_notifier_job_created (CupsNotifier* _sender,
                                       const gchar* text,
                                       const gchar* printer_uri,
                                       const gchar* name,
                                       guint32 state,
                                       const gchar* state_reasons,
                                       gboolean is_accepting_jobs,
                                       guint32 job_id,
                                       guint32 job_state,
                                       const gchar* job_state_reason,
                                       const gchar* job_name,
                                       guint32 job_impressions_completed,
                                       gpointer self)
{
	__lambda9_ (self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
}

static void
__lambda10_ (PrintersJobsView* self)
{
	printers_jobs_view_clear_queue (self);
}

static void
___lambda10__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda10_ ((PrintersJobsView*) self);
}

PrintersJobsView*
printers_jobs_view_construct (GType object_type,
                              PrintersPrinter* printer)
{
	PrintersJobsView * self = NULL;
	Block8Data* _data8_;
	PrintersPrinter* _tmp0_;
	PrintersPrinter* _tmp1_;
	GraniteWidgetsAlertView* alert = NULL;
	GraniteWidgetsAlertView* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	GtkListBox* _tmp7_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp8_;
	GtkListBox* _tmp9_;
	GtkImage* _tmp10_;
	GtkListBox* _tmp11_;
	GList* _tmp12_;
	GList* _tmp13_;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkButton* _tmp19_;
	GtkBox* box = NULL;
	GtkBox* _tmp20_;
	CupsNotifier* notifier = NULL;
	CupsNotifier* _tmp21_;
	GtkButton* _tmp22_;
	g_return_val_if_fail (printer != NULL, NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (printer);
	_g_object_unref0 (_data8_->printer);
	_data8_->printer = _tmp0_;
	self = (PrintersJobsView*) g_object_new (object_type, NULL);
	_data8_->self = g_object_ref (self);
	_tmp1_ = _g_object_ref0 (_data8_->printer);
	_g_object_unref0 (self->priv->printer);
	self->priv->printer = _tmp1_;
	_tmp2_ = granite_widgets_alert_view_new (_ ("Print Queue Is Empty"), _ ("There are no pending jobs in the queue."), "");
	g_object_ref_sink (_tmp2_);
	alert = _tmp2_;
	gtk_widget_show_all ((GtkWidget*) alert);
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->list_box);
	self->priv->list_box = _tmp3_;
	_tmp4_ = self->priv->list_box;
	gtk_list_box_set_selection_mode (_tmp4_, GTK_SELECTION_SINGLE);
	_tmp5_ = self->priv->list_box;
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) alert);
	_tmp6_ = self->priv->list_box;
	gtk_list_box_set_header_func (_tmp6_, (GtkListBoxUpdateHeaderFunc) printers_jobs_view_update_header, g_object_ref (self), g_object_unref);
	_tmp7_ = self->priv->list_box;
	gtk_list_box_set_sort_func (_tmp7_, (GtkListBoxSortFunc) printers_jobs_view_compare, NULL, NULL);
	_tmp8_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp8_);
	scrolled = _tmp8_;
	g_object_set ((GtkWidget*) scrolled, "expand", TRUE, NULL);
	_tmp9_ = self->priv->list_box;
	gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) _tmp9_);
	gtk_widget_show_all ((GtkWidget*) scrolled);
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-clear-all-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp10_);
	_tmp11_ = self->priv->list_box;
	_tmp12_ = gtk_container_get_children ((GtkContainer*) _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = (GtkButton*) gtk_button_new_with_label (_ ("Clear All"));
	gtk_button_set_always_show_image (_tmp14_, TRUE);
	gtk_button_set_image (_tmp14_, (GtkWidget*) _tmp10_);
	_g_object_unref0 (_tmp10_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, g_list_length (_tmp13_) > ((guint) 0));
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->clear_button);
	self->priv->clear_button = _tmp14_;
	(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_list_free (_tmp13_), NULL));
	_tmp15_ = self->priv->clear_button;
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_FLAT);
	_tmp17_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp17_);
	actionbar = _tmp17_;
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) actionbar);
	gtk_style_context_add_class (_tmp18_, GTK_STYLE_CLASS_FLAT);
	_tmp19_ = self->priv->clear_button;
	gtk_container_add ((GtkContainer*) actionbar, (GtkWidget*) _tmp19_);
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp20_);
	box = _tmp20_;
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) scrolled);
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) actionbar);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) box);
	printers_jobs_view_refresh_job_list (self);
	_tmp21_ = cups_notifier_get_default ();
	notifier = _tmp21_;
	g_signal_connect_data (notifier, "job-created", (GCallback) ___lambda9__cups_notifier_job_created, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	_tmp22_ = self->priv->clear_button;
	g_signal_connect_object (_tmp22_, "clicked", (GCallback) ___lambda10__gtk_button_clicked, self, 0);
	_g_object_unref0 (box);
	_g_object_unref0 (actionbar);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (alert);
	block8_data_unref (_data8_);
	_data8_ = NULL;
	return self;
}

PrintersJobsView*
printers_jobs_view_new (PrintersPrinter* printer)
{
	return printers_jobs_view_construct (PRINTERS_TYPE_JOBS_VIEW, printer);
}

static gint
printers_jobs_view_compare (PrintersJobRow* a,
                            PrintersJobRow* b)
{
	gboolean _tmp0_ = FALSE;
	PrintersJob* _tmp1_;
	PrintersJob* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gint result = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp1_ = printers_job_row_get_job (a);
	_tmp2_ = _tmp1_;
	_tmp3_ = printers_job_get_is_ongoing (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		PrintersJob* _tmp5_;
		PrintersJob* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp5_ = printers_job_row_get_job (b);
		_tmp6_ = _tmp5_;
		_tmp7_ = printers_job_get_is_ongoing (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = !_tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = -1;
		return result;
	} else {
		gboolean _tmp9_ = FALSE;
		PrintersJob* _tmp10_;
		PrintersJob* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		_tmp10_ = printers_job_row_get_job (a);
		_tmp11_ = _tmp10_;
		_tmp12_ = printers_job_get_is_ongoing (_tmp11_);
		_tmp13_ = _tmp12_;
		if (!_tmp13_) {
			PrintersJob* _tmp14_;
			PrintersJob* _tmp15_;
			gboolean _tmp16_;
			gboolean _tmp17_;
			_tmp14_ = printers_job_row_get_job (b);
			_tmp15_ = _tmp14_;
			_tmp16_ = printers_job_get_is_ongoing (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp9_ = _tmp17_;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			result = 1;
			return result;
		} else {
			GDateTime* timea = NULL;
			PrintersJob* _tmp18_;
			PrintersJob* _tmp19_;
			GDateTime* _tmp20_;
			GDateTime* timeb = NULL;
			PrintersJob* _tmp21_;
			PrintersJob* _tmp22_;
			GDateTime* _tmp23_;
			GDateTime* _tmp24_;
			_tmp18_ = printers_job_row_get_job (G_TYPE_CHECK_INSTANCE_CAST (a, PRINTERS_TYPE_JOB_ROW, PrintersJobRow));
			_tmp19_ = _tmp18_;
			_tmp20_ = printers_job_get_display_time (_tmp19_);
			timea = _tmp20_;
			_tmp21_ = printers_job_row_get_job (G_TYPE_CHECK_INSTANCE_CAST (b, PRINTERS_TYPE_JOB_ROW, PrintersJobRow));
			_tmp22_ = _tmp21_;
			_tmp23_ = printers_job_get_display_time (_tmp22_);
			timeb = _tmp23_;
			_tmp24_ = timea;
			if (_tmp24_ == NULL) {
				GDateTime* _tmp25_;
				_tmp25_ = timeb;
				if (_tmp25_ == NULL) {
					result = 0;
					_g_date_time_unref0 (timeb);
					_g_date_time_unref0 (timea);
					return result;
				} else {
					result = 1;
					_g_date_time_unref0 (timeb);
					_g_date_time_unref0 (timea);
					return result;
				}
			} else {
				GDateTime* _tmp26_;
				_tmp26_ = timeb;
				if (_tmp26_ == NULL) {
					result = -1;
					_g_date_time_unref0 (timeb);
					_g_date_time_unref0 (timea);
					return result;
				} else {
					GDateTime* _tmp27_;
					GDateTime* _tmp28_;
					_tmp27_ = timeb;
					_tmp28_ = timea;
					result = g_date_time_compare (_tmp27_, _tmp28_);
					_g_date_time_unref0 (timeb);
					_g_date_time_unref0 (timea);
					return result;
				}
			}
			_g_date_time_unref0 (timeb);
			_g_date_time_unref0 (timea);
		}
	}
}

static void
printers_jobs_view_update_header (PrintersJobRow* row1,
                                  PrintersJobRow* row2,
                                  PrintersJobsView* self)
{
	gboolean _tmp0_ = FALSE;
	PrintersJob* _tmp1_;
	PrintersJob* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (row1 != NULL);
	_tmp1_ = printers_job_row_get_job (row1);
	_tmp2_ = _tmp1_;
	_tmp3_ = printers_job_get_is_ongoing (_tmp2_);
	_tmp4_ = _tmp3_;
	if (!_tmp4_) {
		gboolean _tmp5_ = FALSE;
		if (row2 == NULL) {
			_tmp5_ = TRUE;
		} else {
			PrintersJob* _tmp6_;
			PrintersJob* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
			_tmp6_ = printers_job_row_get_job (row2);
			_tmp7_ = _tmp6_;
			_tmp8_ = printers_job_get_is_ongoing (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp5_ = _tmp9_;
		}
		_tmp0_ = _tmp5_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkLabel* label = NULL;
		GtkLabel* _tmp10_;
		GtkLabel* _tmp11_;
		GtkLabel* _tmp12_;
		GtkLabel* _tmp13_;
		GtkStyleContext* _tmp14_;
		GtkLabel* _tmp15_;
		_tmp10_ = (GtkLabel*) gtk_label_new (_ ("Completed Jobs"));
		g_object_ref_sink (_tmp10_);
		label = _tmp10_;
		_tmp11_ = label;
		gtk_label_set_xalign (_tmp11_, (gfloat) 0);
		_tmp12_ = label;
		g_object_set ((GtkWidget*) _tmp12_, "margin", 3, NULL);
		_tmp13_ = label;
		_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
		gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_H4_LABEL);
		_tmp15_ = label;
		gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp15_);
		_g_object_unref0 (label);
	} else {
		gtk_list_box_row_set_header ((GtkListBoxRow*) row1, NULL);
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		PrintersJobsView* self;
		self = _data9_->self;
		_g_object_unref0 (_data9_->dialog);
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static void
___lambda12_ (PrintersJobsView* self,
              GtkWidget* row)
{
	PrintersJob* job = NULL;
	PrintersJob* _tmp0_;
	PrintersJob* _tmp1_;
	PrintersJob* _tmp2_;
	g_return_if_fail (row != NULL);
	_tmp0_ = printers_job_row_get_job (G_TYPE_CHECK_INSTANCE_CAST (row, PRINTERS_TYPE_JOB_ROW, PrintersJobRow));
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	job = _tmp2_;
	printers_job_pause (job);
	printers_job_purge (job);
	_g_object_unref0 (job);
}

static void
____lambda12__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
	___lambda12_ ((PrintersJobsView*) self, widget);
}

static void
__lambda11_ (Block9Data* _data9_,
             gint response_id)
{
	PrintersJobsView* self;
	self = _data9_->self;
	gtk_widget_destroy ((GtkWidget*) _data9_->dialog);
	if (response_id == ((gint) GTK_RESPONSE_OK)) {
		GtkListBox* _tmp0_;
		_tmp0_ = self->priv->list_box;
		gtk_container_foreach ((GtkContainer*) _tmp0_, ____lambda12__gtk_callback, self);
		printers_jobs_view_refresh_job_list (self);
	}
}

static void
___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda11_ (self, response_id);
}

void
printers_jobs_view_clear_queue (PrintersJobsView* self)
{
	Block9Data* _data9_;
	PrintersPrinter* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWindow* _tmp2_;
	PrintersClearQueueDialog* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_data9_->self = g_object_ref (self);
	_tmp0_ = self->priv->printer;
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
	_tmp3_ = printers_clear_queue_dialog_new (_tmp0_);
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, _tmp2_);
	_g_object_unref0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_data9_->dialog = _tmp3_;
	g_signal_connect_data ((GtkDialog*) _data9_->dialog, "response", (GCallback) ___lambda11__gtk_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
	gtk_window_present ((GtkWindow*) _data9_->dialog);
	block9_data_unref (_data9_);
	_data9_ = NULL;
}

static void
__lambda8_ (PrintersJobsView* self,
            GtkWidget* row)
{
	GtkListBox* _tmp0_;
	g_return_if_fail (row != NULL);
	_tmp0_ = self->priv->list_box;
	gtk_container_remove ((GtkContainer*) _tmp0_, row);
}

static void
___lambda8__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
	__lambda8_ ((PrintersJobsView*) self, widget);
}

static void
printers_jobs_view_refresh_job_list (PrintersJobsView* self)
{
	GtkListBox* _tmp0_;
	GeeTreeSet* jobs = NULL;
	PrintersPrinter* _tmp1_;
	GeeTreeSet* _tmp2_;
	GtkButton* _tmp13_;
	GtkListBox* _tmp14_;
	GList* _tmp15_;
	GList* _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->list_box;
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda8__gtk_callback, self);
	_tmp1_ = self->priv->printer;
	_tmp2_ = printers_printer_get_jobs (_tmp1_, TRUE, CUPS_WHICHJOBS_ALL);
	jobs = _tmp2_;
	{
		GeeIterator* _job_it = NULL;
		GeeTreeSet* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp3_ = jobs;
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
		_job_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			PrintersJob* job = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GtkListBox* _tmp8_;
			PrintersPrinter* _tmp9_;
			PrintersJob* _tmp10_;
			PrintersJobRow* _tmp11_;
			PrintersJobRow* _tmp12_;
			_tmp5_ = _job_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _job_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			job = (PrintersJob*) _tmp7_;
			_tmp8_ = self->priv->list_box;
			_tmp9_ = self->priv->printer;
			_tmp10_ = job;
			_tmp11_ = printers_job_row_new (_tmp9_, _tmp10_);
			g_object_ref_sink (_tmp11_);
			_tmp12_ = _tmp11_;
			gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp12_);
			_g_object_unref0 (_tmp12_);
			_g_object_unref0 (job);
		}
		_g_object_unref0 (_job_it);
	}
	_tmp13_ = self->priv->clear_button;
	_tmp14_ = self->priv->list_box;
	_tmp15_ = gtk_container_get_children ((GtkContainer*) _tmp14_);
	_tmp16_ = _tmp15_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, g_list_length (_tmp16_) > ((guint) 0));
	(_tmp16_ == NULL) ? NULL : (_tmp16_ = (g_list_free (_tmp16_), NULL));
	_g_object_unref0 (jobs);
}

static void
printers_jobs_view_class_init (PrintersJobsViewClass * klass,
                               gpointer klass_data)
{
	printers_jobs_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PrintersJobsView_private_offset);
	G_OBJECT_CLASS (klass)->finalize = printers_jobs_view_finalize;
}

static void
printers_jobs_view_instance_init (PrintersJobsView * self,
                                  gpointer klass)
{
	self->priv = printers_jobs_view_get_instance_private (self);
}

static void
printers_jobs_view_finalize (GObject * obj)
{
	PrintersJobsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_JOBS_VIEW, PrintersJobsView);
	_g_object_unref0 (self->priv->printer);
	_g_object_unref0 (self->priv->list_box);
	_g_object_unref0 (self->priv->clear_button);
	G_OBJECT_CLASS (printers_jobs_view_parent_class)->finalize (obj);
}

static GType
printers_jobs_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersJobsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_jobs_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersJobsView), 0, (GInstanceInitFunc) printers_jobs_view_instance_init, NULL };
	GType printers_jobs_view_type_id;
	printers_jobs_view_type_id = g_type_register_static (gtk_frame_get_type (), "PrintersJobsView", &g_define_type_info, 0);
	PrintersJobsView_private_offset = g_type_add_instance_private (printers_jobs_view_type_id, sizeof (PrintersJobsViewPrivate));
	return printers_jobs_view_type_id;
}

GType
printers_jobs_view_get_type (void)
{
	static volatile gsize printers_jobs_view_type_id__volatile = 0;
	if (g_once_init_enter (&printers_jobs_view_type_id__volatile)) {
		GType printers_jobs_view_type_id;
		printers_jobs_view_type_id = printers_jobs_view_get_type_once ();
		g_once_init_leave (&printers_jobs_view_type_id__volatile, printers_jobs_view_type_id);
	}
	return printers_jobs_view_type_id__volatile;
}

