/* InkLevel.c generated by valac 0.54.8, the Vala compiler
 * generated from InkLevel.vala, do not modify */

/*-
 * Copyright 2015-2022 elementary, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define PRINTERS_INK_LEVEL_STYLE_CLASS "\n    block.filled {\n        background-color: #%s;\n    }\n    "

enum  {
	PRINTERS_INK_LEVEL_0_PROPERTY,
	PRINTERS_INK_LEVEL_PRINTER_PROPERTY,
	PRINTERS_INK_LEVEL_NUM_PROPERTIES
};
static GParamSpec* printers_ink_level_properties[PRINTERS_INK_LEVEL_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _printers_printer_color_level_unref0(var) ((var == NULL) ? NULL : (var = (printers_printer_color_level_unref (var), NULL)))

struct _PrintersInkLevelPrivate {
	PrintersPrinter* _printer;
};

static gint PrintersInkLevel_private_offset;
static gpointer printers_ink_level_parent_class = NULL;

static const gchar* printers_ink_level_get_translated_name (PrintersInkLevel* self,
                                                     const gchar* name);
static GObject * printers_ink_level_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void printers_ink_level_finalize (GObject * obj);
static GType printers_ink_level_get_type_once (void);
static void _vala_printers_ink_level_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_printers_ink_level_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
printers_ink_level_get_instance_private (PrintersInkLevel* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersInkLevel_private_offset);
}

PrintersInkLevel*
printers_ink_level_construct (GType object_type,
                              PrintersPrinter* printer)
{
	PrintersInkLevel * self = NULL;
	g_return_val_if_fail (printer != NULL, NULL);
	self = (PrintersInkLevel*) g_object_new (object_type, "printer", printer, NULL);
	return self;
}

PrintersInkLevel*
printers_ink_level_new (PrintersPrinter* printer)
{
	return printers_ink_level_construct (PRINTERS_TYPE_INK_LEVEL, printer);
}

static const gchar*
printers_ink_level_get_translated_name (PrintersInkLevel* self,
                                        const gchar* name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	static GQuark _tmp1_label6 = 0;
	static GQuark _tmp1_label7 = 0;
	static GQuark _tmp1_label8 = 0;
	static GQuark _tmp1_label9 = 0;
	static GQuark _tmp1_label10 = 0;
	static GQuark _tmp1_label11 = 0;
	static GQuark _tmp1_label12 = 0;
	static GQuark _tmp1_label13 = 0;
	static GQuark _tmp1_label14 = 0;
	static GQuark _tmp1_label15 = 0;
	static GQuark _tmp1_label16 = 0;
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if ((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("black(PGBK)")))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Black(PGBK)"))))) {
		switch (0) {
			default:
			{
				result = _ ("Black (PGBK)");
				return result;
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("black(BK)")))) || (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("Black(BK)"))))) {
		switch (0) {
			default:
			{
				result = _ ("Black (BK)");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("black")))) || (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("black ink"))))) || (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("Black"))))) {
		switch (0) {
			default:
			{
				result = _ ("Black");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("yellow")))) || (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("yellow ink"))))) || (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("Yellow"))))) {
		switch (0) {
			default:
			{
				result = _ ("Yellow");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("cyan")))) || (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("cyan ink"))))) || (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("Cyan"))))) {
		switch (0) {
			default:
			{
				result = _ ("Cyan");
				return result;
			}
		}
	} else if (((_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("magenta")))) || (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("magenta ink"))))) || (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("Magenta"))))) {
		switch (0) {
			default:
			{
				result = _ ("Magenta");
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("tri-color ink")))) {
		switch (0) {
			default:
			{
				result = _ ("Tri-color");
				return result;
			}
		}
	}
	result = name;
	return result;
}

PrintersPrinter*
printers_ink_level_get_printer (PrintersInkLevel* self)
{
	PrintersPrinter* result;
	PrintersPrinter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_printer;
	result = _tmp0_;
	return result;
}

static void
printers_ink_level_set_printer (PrintersInkLevel* self,
                                PrintersPrinter* value)
{
	PrintersPrinter* old_value;
	g_return_if_fail (self != NULL);
	old_value = printers_ink_level_get_printer (self);
	if (old_value != value) {
		self->priv->_printer = value;
		g_object_notify_by_pspec ((GObject *) self, printers_ink_level_properties[PRINTERS_INK_LEVEL_PRINTER_PROPERTY]);
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static GObject *
printers_ink_level_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PrintersInkLevel * self;
	GeeArrayList* colors = NULL;
	PrintersPrinter* _tmp0_;
	GeeArrayList* _tmp1_;
	GtkSizeGroup* size_group = NULL;
	GtkSizeGroup* _tmp2_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (printers_ink_level_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	gtk_flow_box_set_homogeneous ((GtkFlowBox*) self, TRUE);
	gtk_flow_box_set_column_spacing ((GtkFlowBox*) self, (guint) 12);
	gtk_flow_box_set_row_spacing ((GtkFlowBox*) self, (guint) 24);
	gtk_flow_box_set_max_children_per_line ((GtkFlowBox*) self, (guint) 30);
	_tmp0_ = self->priv->_printer;
	_tmp1_ = printers_printer_get_color_levels (_tmp0_);
	colors = _tmp1_;
	_tmp2_ = gtk_size_group_new (GTK_SIZE_GROUP_VERTICAL);
	size_group = _tmp2_;
	{
		GeeArrayList* _color_list = NULL;
		GeeArrayList* _tmp3_;
		gint _color_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _color_index = 0;
		_tmp3_ = colors;
		_color_list = _tmp3_;
		_tmp4_ = _color_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_color_size = _tmp6_;
		_color_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			PrintersPrinterColorLevel* color = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			gchar** colors_codes = NULL;
			gchar* _tmp11_;
			gchar** _tmp12_;
			gint colors_codes_length1;
			gint _colors_codes_size_;
			PrintersPrinterColorLevel* _tmp13_;
			const gchar* _tmp14_;
			GtkBox* ink_box = NULL;
			GtkBox* _tmp19_;
			const gchar* _tmp44_ = NULL;
			PrintersPrinterColorLevel* _tmp45_;
			const gchar* _tmp46_;
			GtkLabel* label = NULL;
			const gchar* _tmp47_;
			GtkLabel* _tmp48_ = NULL;
			GtkBox* color_box = NULL;
			GtkBox* _tmp49_;
			GtkBox* _tmp50_;
			GtkBox* _tmp51_;
			GtkBox* _tmp52_;
			GtkLabel* _tmp53_;
			GtkSizeGroup* _tmp54_;
			GtkLabel* _tmp55_;
			GtkBox* _tmp56_;
			_color_index = _color_index + 1;
			_tmp7_ = _color_index;
			_tmp8_ = _color_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _color_list;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _color_index);
			color = (PrintersPrinterColorLevel*) _tmp10_;
			_tmp11_ = g_strdup ("3689E6");
			_tmp12_ = g_new0 (gchar*, 2 + 1);
			_tmp12_[0] = NULL;
			_tmp12_[1] = _tmp11_;
			colors_codes = _tmp12_;
			colors_codes_length1 = 2;
			_colors_codes_size_ = colors_codes_length1;
			_tmp13_ = color;
			_tmp14_ = _tmp13_->color;
			if (string_contains (_tmp14_, "#")) {
				PrintersPrinterColorLevel* _tmp15_;
				const gchar* _tmp16_;
				gchar** _tmp17_;
				gchar** _tmp18_;
				_tmp15_ = color;
				_tmp16_ = _tmp15_->color;
				_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, "#", 0);
				colors_codes = (_vala_array_free (colors_codes, colors_codes_length1, (GDestroyNotify) g_free), NULL);
				colors_codes = _tmp18_;
				colors_codes_length1 = _vala_array_length (_tmp17_);
				_colors_codes_size_ = colors_codes_length1;
			}
			_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
			g_object_ref_sink (_tmp19_);
			ink_box = _tmp19_;
			{
				gint i = 0;
				i = 1;
				{
					gboolean _tmp20_ = FALSE;
					_tmp20_ = TRUE;
					while (TRUE) {
						gchar** _tmp22_;
						gint _tmp22__length1;
						gchar* css_color = NULL;
						gchar** _tmp23_;
						gint _tmp23__length1;
						const gchar* _tmp24_;
						gchar* _tmp25_;
						GtkLevelBar* level = NULL;
						PrintersPrinterColorLevel* _tmp26_;
						PrintersPrinterColorLevel* _tmp27_;
						PrintersPrinterColorLevel* _tmp28_;
						GtkLevelBar* _tmp29_ = NULL;
						GtkCssProvider* provider = NULL;
						GtkCssProvider* _tmp30_;
						GtkBox* _tmp42_;
						GtkLevelBar* _tmp43_;
						if (!_tmp20_) {
							gint _tmp21_;
							_tmp21_ = i;
							i = _tmp21_ + 1;
						}
						_tmp20_ = FALSE;
						_tmp22_ = colors_codes;
						_tmp22__length1 = colors_codes_length1;
						if (!(i < _tmp22__length1)) {
							break;
						}
						_tmp23_ = colors_codes;
						_tmp23__length1 = colors_codes_length1;
						_tmp24_ = _tmp23_[i];
						_tmp25_ = g_strdup_printf (PRINTERS_INK_LEVEL_STYLE_CLASS, _tmp24_);
						css_color = _tmp25_;
						_tmp26_ = color;
						_tmp27_ = color;
						_tmp28_ = color;
						_tmp29_ = (GtkLevelBar*) gtk_level_bar_new_for_interval ((gdouble) _tmp26_->level_min, (gdouble) _tmp27_->level_max);
						g_object_set ((GtkWidget*) _tmp29_, "height-request", 64, NULL);
						gtk_widget_set_hexpand ((GtkWidget*) _tmp29_, TRUE);
						gtk_widget_set_vexpand ((GtkWidget*) _tmp29_, TRUE);
						gtk_level_bar_set_inverted (_tmp29_, TRUE);
						gtk_orientable_set_orientation ((GtkOrientable*) _tmp29_, GTK_ORIENTATION_VERTICAL);
						gtk_level_bar_set_value (_tmp29_, (gdouble) _tmp28_->level);
						g_object_ref_sink (_tmp29_);
						level = _tmp29_;
						_tmp30_ = gtk_css_provider_new ();
						provider = _tmp30_;
						{
							GtkCssProvider* _tmp31_;
							const gchar* _tmp32_;
							const gchar* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							GtkLevelBar* _tmp36_;
							GtkStyleContext* _tmp37_;
							GtkCssProvider* _tmp38_;
							_tmp31_ = provider;
							_tmp32_ = css_color;
							_tmp33_ = css_color;
							_tmp34_ = strlen (_tmp33_);
							_tmp35_ = _tmp34_;
							gtk_css_provider_load_from_data (_tmp31_, _tmp32_, (gssize) _tmp35_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch0_g_error;
							}
							_tmp36_ = level;
							_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
							_tmp38_ = provider;
							gtk_style_context_add_provider (_tmp37_, (GtkStyleProvider*) _tmp38_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							GError* _tmp39_;
							const gchar* _tmp40_;
							const gchar* _tmp41_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp39_ = e;
							_tmp40_ = _tmp39_->message;
							_tmp41_ = css_color;
							g_warning ("InkLevel.vala:70: Could not create CSS Provider: %s\nStylesheet:\n%s", _tmp40_, _tmp41_);
							_g_error_free0 (e);
						}
						__finally0:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_object_unref0 (provider);
							_g_object_unref0 (level);
							_g_free0 (css_color);
							_g_object_unref0 (ink_box);
							colors_codes = (_vala_array_free (colors_codes, colors_codes_length1, (GDestroyNotify) g_free), NULL);
							_printers_printer_color_level_unref0 (color);
							_g_object_unref0 (size_group);
							_g_object_unref0 (colors);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
						}
						_tmp42_ = ink_box;
						_tmp43_ = level;
						gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
						_g_object_unref0 (provider);
						_g_object_unref0 (level);
						_g_free0 (css_color);
					}
				}
			}
			_tmp45_ = color;
			_tmp46_ = _tmp45_->name;
			_tmp44_ = _tmp46_;
			if (_tmp44_ == NULL) {
				_tmp44_ = "black";
			}
			_tmp47_ = printers_ink_level_get_translated_name (self, _tmp44_);
			_tmp48_ = (GtkLabel*) gtk_label_new (_tmp47_);
			gtk_label_set_justify (_tmp48_, GTK_JUSTIFY_CENTER);
			g_object_set (_tmp48_, "wrap", TRUE, NULL);
			gtk_label_set_max_width_chars (_tmp48_, 10);
			gtk_label_set_yalign (_tmp48_, (gfloat) 0);
			g_object_ref_sink (_tmp48_);
			label = _tmp48_;
			_tmp49_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
			g_object_ref_sink (_tmp49_);
			color_box = _tmp49_;
			_tmp50_ = color_box;
			_tmp51_ = ink_box;
			gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
			_tmp52_ = color_box;
			_tmp53_ = label;
			gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
			_tmp54_ = size_group;
			_tmp55_ = label;
			gtk_size_group_add_widget (_tmp54_, (GtkWidget*) _tmp55_);
			_tmp56_ = color_box;
			gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp56_);
			_g_object_unref0 (color_box);
			_g_object_unref0 (label);
			_g_object_unref0 (ink_box);
			colors_codes = (_vala_array_free (colors_codes, colors_codes_length1, (GDestroyNotify) g_free), NULL);
			_printers_printer_color_level_unref0 (color);
		}
	}
	_g_object_unref0 (size_group);
	_g_object_unref0 (colors);
	return obj;
}

static void
printers_ink_level_class_init (PrintersInkLevelClass * klass,
                               gpointer klass_data)
{
	printers_ink_level_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PrintersInkLevel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_printers_ink_level_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_printers_ink_level_set_property;
	G_OBJECT_CLASS (klass)->constructor = printers_ink_level_constructor;
	G_OBJECT_CLASS (klass)->finalize = printers_ink_level_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_INK_LEVEL_PRINTER_PROPERTY, printers_ink_level_properties[PRINTERS_INK_LEVEL_PRINTER_PROPERTY] = g_param_spec_object ("printer", "printer", "printer", PRINTERS_TYPE_PRINTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
printers_ink_level_instance_init (PrintersInkLevel * self,
                                  gpointer klass)
{
	self->priv = printers_ink_level_get_instance_private (self);
}

static void
printers_ink_level_finalize (GObject * obj)
{
	PrintersInkLevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	G_OBJECT_CLASS (printers_ink_level_parent_class)->finalize (obj);
}

static GType
printers_ink_level_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersInkLevelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_ink_level_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersInkLevel), 0, (GInstanceInitFunc) printers_ink_level_instance_init, NULL };
	GType printers_ink_level_type_id;
	printers_ink_level_type_id = g_type_register_static (gtk_flow_box_get_type (), "PrintersInkLevel", &g_define_type_info, 0);
	PrintersInkLevel_private_offset = g_type_add_instance_private (printers_ink_level_type_id, sizeof (PrintersInkLevelPrivate));
	return printers_ink_level_type_id;
}

GType
printers_ink_level_get_type (void)
{
	static volatile gsize printers_ink_level_type_id__volatile = 0;
	if (g_once_init_enter (&printers_ink_level_type_id__volatile)) {
		GType printers_ink_level_type_id;
		printers_ink_level_type_id = printers_ink_level_get_type_once ();
		g_once_init_leave (&printers_ink_level_type_id__volatile, printers_ink_level_type_id);
	}
	return printers_ink_level_type_id__volatile;
}

static void
_vala_printers_ink_level_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	PrintersInkLevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	switch (property_id) {
		case PRINTERS_INK_LEVEL_PRINTER_PROPERTY:
		g_value_set_object (value, printers_ink_level_get_printer (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_printers_ink_level_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	PrintersInkLevel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_INK_LEVEL, PrintersInkLevel);
	switch (property_id) {
		case PRINTERS_INK_LEVEL_PRINTER_PROPERTY:
		printers_ink_level_set_printer (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

