/* PrinterRow.c generated by valac 0.54.8, the Vala compiler
 * generated from PrinterRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2015 - 2022 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	PRINTERS_PRINTER_ROW_0_PROPERTY,
	PRINTERS_PRINTER_ROW_PRINTER_PROPERTY,
	PRINTERS_PRINTER_ROW_NUM_PROPERTIES
};
static GParamSpec* printers_printer_row_properties[PRINTERS_PRINTER_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PrintersPrinterRowPrivate {
	PrintersPrinter* _printer;
	GtkImage* printer_image;
	GtkImage* status_image;
	GtkLabel* name_label;
	GtkLabel* status_label;
};

static gint PrintersPrinterRow_private_offset;
static gpointer printers_printer_row_parent_class = NULL;

static void printers_printer_row_update_status (PrintersPrinterRow* self);
static GObject * printers_printer_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _printers_printer_row___lambda39_ (PrintersPrinterRow* self);
static void __printers_printer_row___lambda39__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _printers_printer_row___lambda40_ (PrintersPrinterRow* self);
static void __printers_printer_row___lambda40__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _printers_printer_row___lambda41_ (PrintersPrinterRow* self);
static void __printers_printer_row___lambda41__printers_printer_deleted (PrintersPrinter* _sender,
                                                                  gpointer self);
static void printers_printer_row_finalize (GObject * obj);
static GType printers_printer_row_get_type_once (void);
static void _vala_printers_printer_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_printers_printer_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
printers_printer_row_get_instance_private (PrintersPrinterRow* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersPrinterRow_private_offset);
}

PrintersPrinterRow*
printers_printer_row_construct (GType object_type,
                                PrintersPrinter* printer)
{
	PrintersPrinterRow * self = NULL;
	g_return_val_if_fail (printer != NULL, NULL);
	self = (PrintersPrinterRow*) g_object_new (object_type, "printer", printer, NULL);
	return self;
}

PrintersPrinterRow*
printers_printer_row_new (PrintersPrinter* printer)
{
	return printers_printer_row_construct (PRINTERS_TYPE_PRINTER_ROW, printer);
}

static void
printers_printer_row_update_status (PrintersPrinterRow* self)
{
	PrintersPrinter* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_printer;
	_tmp1_ = printers_printer_get_is_enabled (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkLabel* _tmp3_;
		PrintersPrinter* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		PrintersPrinter* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		GQuark _tmp16_ = 0U;
		static GQuark _tmp15_label0 = 0;
		static GQuark _tmp15_label1 = 0;
		static GQuark _tmp15_label2 = 0;
		static GQuark _tmp15_label3 = 0;
		static GQuark _tmp15_label4 = 0;
		static GQuark _tmp15_label5 = 0;
		static GQuark _tmp15_label6 = 0;
		static GQuark _tmp15_label7 = 0;
		static GQuark _tmp15_label8 = 0;
		_tmp3_ = self->priv->status_label;
		_tmp4_ = self->priv->_printer;
		_tmp5_ = printers_printer_get_state_reasons (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_markup_escape_text (_tmp6_, (gssize) -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strdup_printf ("<span font_size=\"small\">%s</span>", _tmp8_);
		_tmp10_ = _tmp9_;
		gtk_label_set_label (_tmp3_, _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		_tmp11_ = self->priv->_printer;
		_tmp12_ = printers_printer_get_state_reasons_raw (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = _tmp13_;
		_tmp16_ = (NULL == _tmp14_) ? 0 : g_quark_from_string (_tmp14_);
		if (_tmp16_ == ((0 != _tmp15_label0) ? _tmp15_label0 : (_tmp15_label0 = g_quark_from_static_string ("offline")))) {
			switch (0) {
				default:
				{
					GtkImage* _tmp17_;
					_tmp17_ = self->priv->status_image;
					g_object_set (_tmp17_, "icon-name", "user-offline", NULL);
					break;
				}
			}
		} else if ((_tmp16_ == ((0 != _tmp15_label1) ? _tmp15_label1 : (_tmp15_label1 = g_quark_from_static_string ("none")))) || (_tmp16_ == ((0 != _tmp15_label2) ? _tmp15_label2 : (_tmp15_label2 = g_quark_from_static_string (NULL))))) {
			switch (0) {
				default:
				{
					GtkImage* _tmp18_;
					_tmp18_ = self->priv->status_image;
					g_object_set (_tmp18_, "icon-name", "user-available", NULL);
					break;
				}
			}
		} else if ((((((_tmp16_ == ((0 != _tmp15_label3) ? _tmp15_label3 : (_tmp15_label3 = g_quark_from_static_string ("developer-low")))) || (_tmp16_ == ((0 != _tmp15_label4) ? _tmp15_label4 : (_tmp15_label4 = g_quark_from_static_string ("marker-supply-low"))))) || (_tmp16_ == ((0 != _tmp15_label5) ? _tmp15_label5 : (_tmp15_label5 = g_quark_from_static_string ("marker-waste-almost-full"))))) || (_tmp16_ == ((0 != _tmp15_label6) ? _tmp15_label6 : (_tmp15_label6 = g_quark_from_static_string ("media-low"))))) || (_tmp16_ == ((0 != _tmp15_label7) ? _tmp15_label7 : (_tmp15_label7 = g_quark_from_static_string ("opc-near-eol"))))) || (_tmp16_ == ((0 != _tmp15_label8) ? _tmp15_label8 : (_tmp15_label8 = g_quark_from_static_string ("toner-low"))))) {
			switch (0) {
				default:
				{
					GtkImage* _tmp19_;
					_tmp19_ = self->priv->status_image;
					g_object_set (_tmp19_, "icon-name", "user-away", NULL);
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					GtkImage* _tmp20_;
					_tmp20_ = self->priv->status_image;
					g_object_set (_tmp20_, "icon-name", "user-busy", NULL);
					break;
				}
			}
		}
	} else {
		GtkImage* _tmp21_;
		GtkLabel* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		_tmp21_ = self->priv->status_image;
		g_object_set (_tmp21_, "icon-name", "user-offline", NULL);
		_tmp22_ = self->priv->status_label;
		_tmp23_ = g_strdup_printf ("<span font_size=\"small\">%s</span>", _ ("Disabled"));
		_tmp24_ = _tmp23_;
		gtk_label_set_label (_tmp22_, _tmp24_);
		_g_free0 (_tmp24_);
	}
}

PrintersPrinter*
printers_printer_row_get_printer (PrintersPrinterRow* self)
{
	PrintersPrinter* result;
	PrintersPrinter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_printer;
	result = _tmp0_;
	return result;
}

static void
printers_printer_row_set_printer (PrintersPrinterRow* self,
                                  PrintersPrinter* value)
{
	PrintersPrinter* old_value;
	g_return_if_fail (self != NULL);
	old_value = printers_printer_row_get_printer (self);
	if (old_value != value) {
		self->priv->_printer = value;
		g_object_notify_by_pspec ((GObject *) self, printers_printer_row_properties[PRINTERS_PRINTER_ROW_PRINTER_PROPERTY]);
	}
}

static void
_printers_printer_row___lambda39_ (PrintersPrinterRow* self)
{
	printers_printer_row_update_status (self);
}

static void
__printers_printer_row___lambda39__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
	_printers_printer_row___lambda39_ ((PrintersPrinterRow*) self);
}

static void
_printers_printer_row___lambda40_ (PrintersPrinterRow* self)
{
	PrintersRemoveDialog* remove_dialog = NULL;
	PrintersPrinter* _tmp0_;
	PrintersRemoveDialog* _tmp1_;
	PrintersRemoveDialog* _tmp2_;
	GtkWidget* _tmp3_;
	PrintersRemoveDialog* _tmp4_;
	_tmp0_ = self->priv->_printer;
	_tmp1_ = printers_remove_dialog_new (_tmp0_);
	g_object_ref_sink (_tmp1_);
	remove_dialog = _tmp1_;
	_tmp2_ = remove_dialog;
	_tmp3_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	gtk_window_set_transient_for ((GtkWindow*) _tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
	_tmp4_ = remove_dialog;
	gtk_window_present ((GtkWindow*) _tmp4_);
	_g_object_unref0 (remove_dialog);
}

static void
__printers_printer_row___lambda40__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_printers_printer_row___lambda40_ ((PrintersPrinterRow*) self);
}

static void
_printers_printer_row___lambda41_ (PrintersPrinterRow* self)
{
	PrintersPrinterPage* _tmp0_;
	_tmp0_ = self->page;
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
__printers_printer_row___lambda41__printers_printer_deleted (PrintersPrinter* _sender,
                                                             gpointer self)
{
	_printers_printer_row___lambda41_ ((PrintersPrinterRow*) self);
}

static GObject *
printers_printer_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PrintersPrinterRow * self;
	GtkButton* remove_button = NULL;
	gchar* _tmp0_;
	GtkButton* _tmp1_ = NULL;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkImage* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp18_;
	GtkOverlay* _tmp19_;
	GtkOverlay* _tmp20_;
	GtkImage* _tmp21_;
	GtkOverlay* _tmp22_;
	GtkImage* _tmp23_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GtkOverlay* _tmp29_;
	GtkGrid* _tmp30_;
	GtkLabel* _tmp31_;
	GtkGrid* _tmp32_;
	GtkLabel* _tmp33_;
	GtkGrid* _tmp34_;
	GtkButton* _tmp35_;
	GtkGrid* _tmp36_;
	PrintersPrinter* _tmp37_;
	PrintersPrinterPage* _tmp38_;
	PrintersPrinter* _tmp39_;
	PrintersPrinter* _tmp40_;
	GtkLabel* _tmp41_;
	PrintersPrinter* _tmp42_;
	GtkButton* _tmp43_;
	PrintersPrinter* _tmp44_;
	parent_class = G_OBJECT_CLASS (printers_printer_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PRINTER_ROW, PrintersPrinterRow);
	_tmp0_ = g_strdup (_ ("Remove this printer"));
	_tmp1_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _tmp0_);
	_g_free0 (_tmp0_);
	g_object_ref_sink (_tmp1_);
	remove_button = _tmp1_;
	_tmp2_ = remove_button;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, GTK_STYLE_CLASS_FLAT);
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->name_label);
	self->priv->name_label = _tmp4_;
	_tmp5_ = self->priv->name_label;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, "h3");
	_tmp7_ = self->priv->name_label;
	gtk_label_set_ellipsize (_tmp7_, PANGO_ELLIPSIZE_END);
	_tmp8_ = self->priv->name_label;
	gtk_label_set_xalign (_tmp8_, (gfloat) 0);
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->status_label);
	self->priv->status_label = _tmp9_;
	_tmp10_ = self->priv->status_label;
	gtk_label_set_use_markup (_tmp10_, TRUE);
	_tmp11_ = self->priv->status_label;
	gtk_label_set_ellipsize (_tmp11_, PANGO_ELLIPSIZE_END);
	_tmp12_ = self->priv->status_label;
	gtk_label_set_xalign (_tmp12_, (gfloat) 0);
	_tmp13_ = (GtkImage*) gtk_image_new_from_icon_name ("printer", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->printer_image);
	self->priv->printer_image = _tmp13_;
	_tmp14_ = self->priv->printer_image;
	gtk_image_set_pixel_size (_tmp14_, 32);
	_tmp15_ = (GtkImage*) gtk_image_new_from_icon_name ("user-available", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->status_image);
	self->priv->status_image = _tmp15_;
	_tmp16_ = self->priv->status_image;
	_tmp17_ = self->priv->status_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_END);
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_END);
	_tmp18_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp18_);
	overlay = _tmp18_;
	_tmp19_ = overlay;
	g_object_set ((GtkWidget*) _tmp19_, "width-request", 38, NULL);
	_tmp20_ = overlay;
	_tmp21_ = self->priv->printer_image;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = overlay;
	_tmp23_ = self->priv->status_image;
	gtk_overlay_add_overlay (_tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp24_);
	grid = _tmp24_;
	_tmp25_ = grid;
	g_object_set ((GtkWidget*) _tmp25_, "margin", 6, NULL);
	_tmp26_ = grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp26_, 3);
	_tmp27_ = grid;
	gtk_grid_set_column_spacing (_tmp27_, 3);
	_tmp28_ = grid;
	_tmp29_ = overlay;
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 0, 0, 1, 2);
	_tmp30_ = grid;
	_tmp31_ = self->priv->name_label;
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 1, 0, 1, 1);
	_tmp32_ = grid;
	_tmp33_ = self->priv->status_label;
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 1, 1, 1, 1);
	_tmp34_ = grid;
	_tmp35_ = remove_button;
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 2, 0, 2, 2);
	_tmp36_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->_printer;
	_tmp38_ = printers_printer_page_new (_tmp37_);
	g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->page);
	self->page = _tmp38_;
	_tmp39_ = self->priv->_printer;
	g_object_bind_property_with_closures ((GObject*) _tmp39_, "info", (GObject*) self, "tooltip-text", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp40_ = self->priv->_printer;
	_tmp41_ = self->priv->name_label;
	g_object_bind_property_with_closures ((GObject*) _tmp40_, "info", (GObject*) _tmp41_, "label", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp42_ = self->priv->_printer;
	g_signal_connect_object ((GObject*) _tmp42_, "notify::state", (GCallback) __printers_printer_row___lambda39__g_object_notify, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp43_ = remove_button;
	g_signal_connect_object (_tmp43_, "clicked", (GCallback) __printers_printer_row___lambda40__gtk_button_clicked, self, 0);
	_tmp44_ = self->priv->_printer;
	g_signal_connect_object (_tmp44_, "deleted", (GCallback) __printers_printer_row___lambda41__printers_printer_deleted, self, 0);
	printers_printer_row_update_status (self);
	_g_object_unref0 (grid);
	_g_object_unref0 (overlay);
	_g_object_unref0 (remove_button);
	return obj;
}

static void
printers_printer_row_class_init (PrintersPrinterRowClass * klass,
                                 gpointer klass_data)
{
	printers_printer_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PrintersPrinterRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_printers_printer_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_printers_printer_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = printers_printer_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = printers_printer_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_ROW_PRINTER_PROPERTY, printers_printer_row_properties[PRINTERS_PRINTER_ROW_PRINTER_PROPERTY] = g_param_spec_object ("printer", "printer", "printer", PRINTERS_TYPE_PRINTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
printers_printer_row_instance_init (PrintersPrinterRow * self,
                                    gpointer klass)
{
	self->priv = printers_printer_row_get_instance_private (self);
}

static void
printers_printer_row_finalize (GObject * obj)
{
	PrintersPrinterRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PRINTER_ROW, PrintersPrinterRow);
	_g_object_unref0 (self->page);
	_g_object_unref0 (self->priv->printer_image);
	_g_object_unref0 (self->priv->status_image);
	_g_object_unref0 (self->priv->name_label);
	_g_object_unref0 (self->priv->status_label);
	G_OBJECT_CLASS (printers_printer_row_parent_class)->finalize (obj);
}

static GType
printers_printer_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersPrinterRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_printer_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersPrinterRow), 0, (GInstanceInitFunc) printers_printer_row_instance_init, NULL };
	GType printers_printer_row_type_id;
	printers_printer_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "PrintersPrinterRow", &g_define_type_info, 0);
	PrintersPrinterRow_private_offset = g_type_add_instance_private (printers_printer_row_type_id, sizeof (PrintersPrinterRowPrivate));
	return printers_printer_row_type_id;
}

GType
printers_printer_row_get_type (void)
{
	static volatile gsize printers_printer_row_type_id__volatile = 0;
	if (g_once_init_enter (&printers_printer_row_type_id__volatile)) {
		GType printers_printer_row_type_id;
		printers_printer_row_type_id = printers_printer_row_get_type_once ();
		g_once_init_leave (&printers_printer_row_type_id__volatile, printers_printer_row_type_id);
	}
	return printers_printer_row_type_id__volatile;
}

static void
_vala_printers_printer_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	PrintersPrinterRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_PRINTER_ROW, PrintersPrinterRow);
	switch (property_id) {
		case PRINTERS_PRINTER_ROW_PRINTER_PROPERTY:
		g_value_set_object (value, printers_printer_row_get_printer (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_printers_printer_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	PrintersPrinterRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_PRINTER_ROW, PrintersPrinterRow);
	switch (property_id) {
		case PRINTERS_PRINTER_ROW_PRINTER_PROPERTY:
		printers_printer_row_set_printer (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

